//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers  12
#property indicator_color1   clrLime
#property indicator_color2   clrRed
#property indicator_color3   clrDarkGreen
#property indicator_color4   clrMaroon
#property indicator_color5   clrDeepSkyBlue
#property indicator_color6   clrDimGray
#property indicator_color7   clrPaleVioletRed
#property indicator_color8   clrDeepSkyBlue
#property indicator_color9   clrDimGray
#property indicator_color10  clrPaleVioletRed
#property indicator_color11  clrSilver
#property indicator_color12  clrSilver
#property indicator_style6   STYLE_DOT
#property indicator_style8   STYLE_DOT
#property indicator_style9   STYLE_DOT
#property indicator_style10  STYLE_DOT
#property indicator_style12  STYLE_DOT
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2
#property indicator_width4   2
#property indicator_width11  2

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_average2,   // Average 2 (high+low+open+close+close)/5
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_haaverage2, // Heiken ashi average 2
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern ENUM_TIMEFRAMES TimeFrame        = PERIOD_CURRENT;
extern int             BandsPeriod      = 200;
extern enPrices        BandsPrice       = pr_average2;
extern int             DeviationsPeriod = 55;
extern int             FutureBars       = 100;
extern bool            SkipSunday       = false;
extern bool            alertsOn         = false;
extern bool            alertsOnCurrent  = true;
extern bool            alertsMessage    = true;
extern bool            alertsSound      = false;
extern bool            alertsEmail      = false;
extern bool            Interpolate      = true;

//
//
//
//
//

double bandup[];
double banddn[];
double bandmi[];
double banfup[];
double banfdn[];
double banfmi[];
double lrvalue[];
double lrforecast[];
double breakouts[];
double LWUp[],LWDn[];
double RWUp[],RWDn[];
double trend1[];
double trend2[];

string indicatorFileName;
bool   returnBars;
bool   returnFutureSlope;
bool   calculate;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(14);
   SetIndexBuffer(0,LWUp); SetIndexStyle(0, DRAW_HISTOGRAM);
	SetIndexBuffer(1,LWDn); SetIndexStyle(1, DRAW_HISTOGRAM);					
	SetIndexBuffer(2,RWUp); SetIndexStyle(2, DRAW_HISTOGRAM);
	SetIndexBuffer(3,RWDn); SetIndexStyle(3, DRAW_HISTOGRAM);	
   SetIndexBuffer(4,bandup);
   SetIndexBuffer(5,bandmi);
   SetIndexBuffer(6,banddn);
   SetIndexBuffer(7,banfup);
   SetIndexBuffer(8,banfmi);
   SetIndexBuffer(9,banfdn);
   SetIndexBuffer(10,lrvalue);
   SetIndexBuffer(11,lrforecast);
   SetIndexBuffer(12,trend1);		
	SetIndexBuffer(13,trend2);	
   
      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculate         = (TimeFrame==-98);
         returnFutureSlope = (TimeFrame==-98); if (returnFutureSlope) calculate=true;
         returnBars        = (TimeFrame==-99); if (returnBars)        calculate=true;
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
   
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,k,n,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { LWUp[0] = limit+1; return(0); }
         if (ArraySize(breakouts)!=Bars) ArrayResize(breakouts,Bars);

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      for(i=limit; i>=0; i--) 
      {
         double slope;      
         double linreg    = iLRValue(getPrice(BandsPrice,Open,Close,High,Low,i),BandsPeriod,i,slope);
         double deviation = iDeviation(linreg,DeviationsPeriod,i);
            lrvalue[i] = linreg;
            if (i>Bars-1)
            {
               bandup[i] = linreg;
               banddn[i] = linreg;
               bandmi[i] = linreg;
               continue;
            }         
         
         //
         //
         //
         //
         //
         
         bandup[i] = bandup[i+1];
         bandmi[i] = bandmi[i+1];
         banddn[i] = banddn[i+1];
         if (linreg>bandup[i+1] || linreg<banddn[i+1])
         {
            bandup[i] = linreg+2.0*deviation;
            banddn[i] = linreg-2.0*deviation;
            bandmi[i] = linreg;
         }
            LWUp[i] = EMPTY_VALUE; LWDn[i] = EMPTY_VALUE;
		      RWUp[i] = EMPTY_VALUE; RWDn[i] = EMPTY_VALUE; 
            trend1[i] = 0;
            trend2[i] = 0;
            if (Close[i]>bandup[i])                      trend1[i] = 1;
            if (Close[i]<banddn[i])                      trend1[i] =-1;
            if (Close[i]<bandup[i]&&Close[i]>bandmi[i])  trend2[i] = 1;
            if (Close[i]>banddn[i]&&Close[i]<bandmi[i])  trend2[i] =-1;
            
            if (trend1[i] == 1) { LWUp[i] = High[i]; LWDn[i] = Low[i]; }
            if (trend1[i] ==-1) { LWDn[i] = High[i]; LWUp[i] = Low[i]; }
            if (trend2[i] == 1) { RWUp[i] = High[i]; RWDn[i] = Low[i]; }
            if (trend2[i] ==-1) { RWDn[i] = High[i]; RWUp[i] = Low[i]; }
         
         //
         //
         //
         //
         //
         
         if (i==0)
         {
            for (int cross=0; cross<FutureBars; cross++)
            {
               double value = linreg+slope*cross;
                  if (value > bandup[0]) break;
                  if (value < banddn[0]) break;
            }
            for (k=0; k<=cross; k++)
            {
               banfup[cross-k]     = bandup[0];
               banfdn[cross-k]     = banddn[0];
               banfmi[cross-k]     = bandmi[0];
               lrforecast[cross-k] = linreg+slope*k;
            }
         }
         
         //
         //
         //
         //
         //
         
         breakouts[Bars-i-1] = breakouts[Bars-i-2];
            if (lrvalue[i]>bandup[i+1])                           breakouts[Bars-i-1]= 1;
            if (lrvalue[i]<banddn[i+1])                           breakouts[Bars-i-1]=-1;
            if (lrvalue[i]>bandup[i+1] && lrvalue[i]<bandup[i+1]) breakouts[Bars-i-1]= 0;
      }
      
      //
      //
      //
      //
      //
      
      if (!calculate)
      {
         SetIndexShift(7,cross);  SetIndexDrawBegin(7, Bars-cross-1);
         SetIndexShift(8,cross);  SetIndexDrawBegin(8, Bars-cross-1);
         SetIndexShift(9,cross);  SetIndexDrawBegin(9, Bars-cross-1);
         SetIndexShift(11,cross); SetIndexDrawBegin(11,Bars-cross-1);
      }
      if (returnFutureSlope) bandup[0]=slope; else manageAlerts();
      return(0);
   }      
 
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         bandup[i]  = iCustom(NULL,TimeFrame,indicatorFileName,-97,BandsPeriod,BandsPrice,DeviationsPeriod,FutureBars,SkipSunday,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4, y);
         bandmi[i]  = iCustom(NULL,TimeFrame,indicatorFileName,-97,BandsPeriod,BandsPrice,DeviationsPeriod,FutureBars,SkipSunday,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5, y);
         banddn[i]  = iCustom(NULL,TimeFrame,indicatorFileName,-97,BandsPeriod,BandsPrice,DeviationsPeriod,FutureBars,SkipSunday,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,6, y);
         lrvalue[i] = iCustom(NULL,TimeFrame,indicatorFileName,-97,BandsPeriod,BandsPrice,DeviationsPeriod,FutureBars,SkipSunday,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,10,y);
         trend1[i]  = iCustom(NULL,TimeFrame,indicatorFileName,-97,BandsPeriod,BandsPrice,DeviationsPeriod,FutureBars,SkipSunday,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,12,y);
         trend2[i]  = iCustom(NULL,TimeFrame,indicatorFileName,-97,BandsPeriod,BandsPrice,DeviationsPeriod,FutureBars,SkipSunday,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,13,y);  
         
         LWUp[i] = EMPTY_VALUE; LWDn[i] = EMPTY_VALUE;
		   RWUp[i] = EMPTY_VALUE; RWDn[i] = EMPTY_VALUE; 
		   if (trend1[i] == 1) { LWUp[i] = High[i]; LWDn[i] = Low[i]; }
         if (trend1[i] ==-1) { LWDn[i] = High[i]; LWUp[i] = Low[i]; }
         if (trend2[i] == 1) { RWUp[i] = High[i]; RWDn[i] = Low[i]; }
         if (trend2[i] ==-1) { RWDn[i] = High[i]; RWUp[i] = Low[i]; }
                
            //
            //
            //
            //
            //
            
            int barToCheck = iBarShift(NULL,0,iTime(NULL,TimeFrame,y+1));
               breakouts[Bars-i-1] = breakouts[Bars-i-2];
                  if (lrvalue[i]>bandup[barToCheck])                                  breakouts[Bars-i-1]= 1;
                  if (lrvalue[i]<banddn[barToCheck])                                  breakouts[Bars-i-1]=-1;
                  if (lrvalue[i]>bandup[barToCheck] && lrvalue[i]<bandup[barToCheck]) breakouts[Bars-i-1]= 0;
            if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;
            for(k = 1; k < n; k++)
               lrvalue[i+k]  = lrvalue[i] + (lrvalue[i+n]-lrvalue[i])*k/n;
   }

   //
   //
   //
   //
   //
      
   slope  = iCustom(NULL,TimeFrame,indicatorFileName,-98,BandsPeriod,BandsPrice,DeviationsPeriod,FutureBars,SkipSunday,0,0)*Period()/TimeFrame;
   linreg = lrvalue[0];
      for (cross=0; cross<FutureBars*TimeFrame/Period(); cross++)
      {
         value = linreg+slope*cross;
           if (value > bandup[0]) break;
           if (value < banddn[0]) break;
      }
      for (k=0; k<=cross; k++)
      {
           banfup[cross-k]     = bandup[0];
           banfdn[cross-k]     = banddn[0];
           banfmi[cross-k]     = bandmi[0];
           lrforecast[cross-k] = linreg+slope*k;
      }

   //
   //
   //
   //
   //

   SetIndexShift(7,cross);  SetIndexDrawBegin(7, Bars-cross-1);
   SetIndexShift(8,cross);  SetIndexDrawBegin(8, Bars-cross-1);
   SetIndexShift(9,cross);  SetIndexDrawBegin(9, Bars-cross-1);
   SetIndexShift(11,cross); SetIndexDrawBegin(11,Bars-cross-1);
   manageAlerts();
   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int tprice, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (tprice>=pr_haclose)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (tprice)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_haaverage2:  return((haHigh+haLow+haClose+haClose+haOpen)/5.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (tprice)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_average2:  return((high[i]+low[i]+close[i]+close[i]+open[i])/5.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}   

//
//
//
//
//

double workDev[];
double iDeviation(double value, double period, int i, bool isSample=false)
{
   if (ArraySize(workDev)!=Bars) ArrayResize(workDev,Bars); int r = Bars-i-1;

   workDev[r] = value; if (r<period) return(0);   
   
   //
   //
   //
   //
   //

   int k,d;
   double avg = 0; for (k=0,d=0; k<period; d++) if (!isSunday(i,d)) { avg += workDev[r-d]; k++; } avg /= period; 
   double sum = 0; for (k=0,d=0; k<period; d++) if (!isSunday(i,d)) { sum += MathPow(workDev[r-d]-avg,2); k++; }
   if (isSample)
         return(MathSqrt(sum/(period-1.0)));
   else  return(MathSqrt(sum/period));
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double workLr[];
double iLRValue(double value, int period, int i, double& slope)
{
   if (ArraySize(workLr)!=Bars) ArrayResize(workLr,Bars); int r = Bars-i-1;
                 workLr[r] = value;
                 if (r<period) return(value);
                 
   //
   //
   //
   //
   //
                    
   double sumX    = period * (period-1) / 2.0;
   double sumXX   = period * (period-1) * (2.0 * period - 1.0) / 6.0;
   double divisor = MathPow(sumX,2.0) - period * sumXX;
   double SumXY   = 0;
   double SumY    = 0;

         int k=0,d=0;
         for (; k<period; d++)
            if (!isSunday(i,d))
               {
                  SumXY += k*workLr[r-d];
                  SumY  +=   workLr[r-d];
                  k++;
               }                  
   
   //
   //
   //
   //
   //
   
   if( divisor != 0 ) 
         	slope = (period * SumXY - sumX * SumY)/divisor;
   else     slope = 0; 
   return((SumY-slope*sumX)/period + slope*(period-1));
}
bool isSunday(int i, int d) { return(SkipSunday && TimeDayOfWeek(Time[i+d])==0); }


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      
      //
      //
      //
      //
      //
      
      if (breakouts[whichBar] != breakouts[whichBar-1])
      {
         if (breakouts[whichBar] == 1) doAlert(whichBar,"up");
         if (breakouts[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," alb Mogalef bands breakout ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"alb Mogalef bands"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}